.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include blank_dlg.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg == WM_INITDIALOG
           invoke GetDlgItem,hWnd,IDC_LIST
	       mov hList,eax
           invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP,-1
           invoke InsertColumns
            invoke AddLine,addr sz1,addr sz2,addr sz3
    invoke AddLine,addr sz1,addr sz2,addr sz3
   
    invoke AddLine,addr sz1,addr sz2,addr sz3
    invoke AddLine,addr sz1,addr sz2,addr sz3
   
   
    .elseif uMsg == WM_COMMAND

     .if wParam == IDB_EXIT
                   jmp EXIT
 
	
        .elseif wParam==IDB_INSERT
        invoke AddLine,addr sz1,addr sz2,addr sz3
   
           
          .endif
	.elseif uMsg == WM_CLOSE 
	        EXIT:
		    invoke EndDialog,hWnd,0		
		                 
    .elseif uMsg == WM_NOTIFY
            mov edi,lParam
            assume edi:ptr NMLVCUSTOMDRAW
            mov eax,[edi].nmcd.hdr.code
            
      .if eax== NM_CUSTOMDRAW
             mov eax,[edi].nmcd.dwDrawStage
       .if eax==CDDS_PREPAINT
              mov eax,CDRF_NOTIFYITEMDRAW
              ret
          .elseif eax==CDDS_ITEMPREPAINT
                     mov eax,[edi].nmcd.dwItemSpec
                     and eax,1
                     dec eax
                     and eax,(0C9C9C9h-0E2E2E2h)
                     add eax,0E2E2E2h
                     mov dwOldColor,eax
                     mov [edi].clrTextBk,eax
                     mov [edi].clrText,0FF0000h
                     mov eax,CDRF_NOTIFYSUBITEMDRAW
                     ret
          .elseif eax==CDDS_SUBITEM or CDDS_ITEMPREPAINT

                     ;.if [edi].iSubItem==2 ;col
                     ;.if [edi].nmcd.dwItemSpec==8 && [edi].iSubItem==1 ;{8,1}
              .if [edi].nmcd.dwItemSpec==8 || [edi].nmcd.dwItemSpec==1
                        mov [edi].clrTextBk,08fffffh
                        mov [edi].clrText,0FF0000h
                 .else
                      push dwOldColor
                       pop [edi].clrTextBk
                       mov [edi].clrText,0FF0000h
               .endif
        .endif
          mov eax,CDRF_NEWFONT
          ret
      .endif
  .endif
ASSUME edi:nothing           
  ret0:
  xor eax, eax
  ret
DlgProc endp



InsertColumns proc
LOCAL lvc:LV_COLUMN
    invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_FLATSB ,-1
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,offset ListCap1
	mov lvc.lx,100
	invoke SendMessage,hList, LVM_INSERTCOLUMN,0,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT ;CENTER
	mov lvc.pszText,offset ListCap2
	mov lvc.lx,130
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvc
	mov lvc.pszText,offset ListCap3
	mov lvc.lx,120
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 2 ,addr lvc
	
ret
InsertColumns endp

AddLine PROC Location:DWORD,Byte1:DWORD,Byte2:DWORD

    invoke lstrcpy,addr Buffer,Location
    mov	lvi.imask,LVIF_TEXT
    mov	lvi.pszText,offset Buffer
    mov	lvi.iSubItem,0
    invoke	SendMessage,hList,LVM_INSERTITEM,0,addr lvi
    mov	lvi.iItem,eax
    inc	lvi.iSubItem
    invoke lstrcpy,addr Buffer,Byte1
    invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
    inc	lvi.iSubItem
    invoke lstrcpy,addr Buffer,Byte2
    invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
ret   
AddLine ENDP



end start
